Index: boost/filesystem/v2/convenience.hpp
===================================================================
--- boost/filesystem/v2/convenience.hpp	(revision 64557)
+++ boost/filesystem/v2/convenience.hpp	(working copy)
@@ -92,7 +92,7 @@
 	  } 
 # endif
 
-# ifndef BOOST_FILESYSTEM_NARROW_ONLY
+# ifndef BOOST_FILESYSTEM2_NARROW_ONLY
 
     // "do-the-right-thing" overloads  ---------------------------------------//
 
@@ -206,7 +206,7 @@
     };
 
     typedef basic_recursive_directory_iterator<path> recursive_directory_iterator;
-# ifndef BOOST_FILESYSTEM_NARROW_ONLY
+# ifndef BOOST_FILESYSTEM2_NARROW_ONLY
     typedef basic_recursive_directory_iterator<wpath> wrecursive_directory_iterator;
 # endif
 
@@ -325,7 +325,7 @@
     using filesystem2::change_extension;
 # endif
 
-# ifndef BOOST_FILESYSTEM_NARROW_ONLY
+# ifndef BOOST_FILESYSTEM2_NARROW_ONLY
     using filesystem2::wrecursive_directory_iterator;
 # endif
 
Index: boost/filesystem/v2/path.hpp
===================================================================
--- boost/filesystem/v2/path.hpp	(revision 64557)
+++ boost/filesystem/v2/path.hpp	(working copy)
@@ -1536,10 +1536,10 @@
 # ifndef BOOST_FILESYSTEM2_NARROW_ONLY
     using filesystem2::wpath_traits;
     using filesystem2::wpath;
+    using filesystem2::wfilesystem_error;
 # endif
     using filesystem2::basic_filesystem_error;
     using filesystem2::filesystem_error;
-    using filesystem2::wfilesystem_error;
     using filesystem2::portable_posix_name;
     using filesystem2::windows_name;
     using filesystem2::portable_name;
Index: libs/filesystem/v2/test/fstream_test.cpp
===================================================================
--- libs/filesystem/v2/test/fstream_test.cpp	(revision 64557)
+++ libs/filesystem/v2/test/fstream_test.cpp	(working copy)
@@ -25,7 +25,7 @@
 
 #include <boost/filesystem/detail/utf8_codecvt_facet.hpp>
 
-#ifndef BOOST_FILESYSTEM_NARROW_ONLY
+#ifndef BOOST_FILESYSTEM2_NARROW_ONLY
 #  include "lpath.hpp"
 #endif
 
@@ -156,7 +156,7 @@
   std::cout << "path tests:\n";
   test( fs::path( "fstream_test_foo" ) );
 
-#ifndef BOOST_FILESYSTEM_NARROW_ONLY
+#ifndef BOOST_FILESYSTEM2_NARROW_ONLY
 
   // So that tests are run with known encoding, use Boost UTF-8 codecvt
   std::locale global_loc = std::locale();
Index: libs/filesystem/v2/test/operations_test.cpp
===================================================================
--- libs/filesystem/v2/test/operations_test.cpp	(revision 64557)
+++ libs/filesystem/v2/test/operations_test.cpp	(working copy)
@@ -36,7 +36,7 @@
 #include <ctime>
 #include <cstdlib> // for system()
 
-#ifndef BOOST_FILESYSTEM_NARROW_ONLY
+#ifndef BOOST_FILESYSTEM2_NARROW_ONLY
 # define BOOST_BND(BOOST_FUNC_TO_DO) BOOST_FUNC_TO_DO<fs::path>
 #else
 # define BOOST_BND(BOOST_FUNC_TO_DO) BOOST_FUNC_TO_DO
Index: libs/filesystem/v2/test/wide_test.cpp
===================================================================
--- libs/filesystem/v2/test/wide_test.cpp	(revision 64557)
+++ libs/filesystem/v2/test/wide_test.cpp	(working copy)
@@ -19,7 +19,7 @@
 #endif
 
 #include <boost/filesystem/config.hpp>
-# ifdef BOOST_FILESYSTEM_NARROW_ONLY
+# ifdef BOOST_FILESYSTEM2_NARROW_ONLY
 #   error This compiler or standard library does not support wide-character strings or paths
 # endif
 
Index: libs/filesystem/v2/test/convenience_test.cpp
===================================================================
--- libs/filesystem/v2/test/convenience_test.cpp	(revision 64557)
+++ libs/filesystem/v2/test/convenience_test.cpp	(working copy)
@@ -28,7 +28,7 @@
 #include <fstream>
 #include <iostream>
 
-#ifndef BOOST_FILESYSTEM_NARROW_ONLY
+#ifndef BOOST_FILESYSTEM2_NARROW_ONLY
 # define BOOST_FS_IS_EMPTY fs::is_empty
 # define BOOST_BND(BOOST_FUNC_TO_DO) BOOST_FUNC_TO_DO<fs::path>
 #else
Index: libs/filesystem/v2/src/v2_path.cpp
===================================================================
--- libs/filesystem/v2/src/v2_path.cpp	(revision 64557)
+++ libs/filesystem/v2/src/v2_path.cpp	(working copy)
@@ -19,7 +19,7 @@
 
 #include <boost/filesystem/v2/config.hpp>
 
-#ifndef BOOST_FILESYSTEM_NARROW_ONLY
+#ifndef BOOST_FILESYSTEM2_NARROW_ONLY
 
 #include <boost/filesystem/v2/path.hpp>
 #include <boost/scoped_array.hpp>
@@ -174,4 +174,4 @@
   } // namespace filesystem2
 } // namespace boost
 
-#endif // ifndef BOOST_FILESYSTEM_NARROW_ONLY
+#endif // ifndef BOOST_FILESYSTEM2_NARROW_ONLY
Index: libs/filesystem/v2/src/v2_operations.cpp
===================================================================
--- libs/filesystem/v2/src/v2_operations.cpp	(revision 64557)
+++ libs/filesystem/v2/src/v2_operations.cpp	(working copy)
@@ -122,7 +122,7 @@
   inline DWORD get_file_attributes( const char * ph )
     { return ::GetFileAttributesA( ph ); }
 
-# ifndef BOOST_FILESYSTEM_NARROW_ONLY
+# ifndef BOOST_FILESYSTEM2_NARROW_ONLY
 
   inline DWORD get_file_attributes( const wchar_t * ph )
     { return ::GetFileAttributesW( ph ); }
@@ -180,7 +180,7 @@
     {  return ::CreateHardLinkW( from_ph.c_str(), to_ph.c_str(), 0 ) != 0; }
 #endif
   
-# endif // ifndef BOOST_FILESYSTEM_NARROW_ONLY
+# endif // ifndef BOOST_FILESYSTEM2_NARROW_ONLY
 
   template< class String >
   fs::file_status status_template( const String & ph, error_code & ec )
@@ -625,7 +625,7 @@
         status_api( const std::string & ph, error_code & ec )
         { return status_template( ph, ec ); }
 
-#     ifndef BOOST_FILESYSTEM_NARROW_ONLY
+#     ifndef BOOST_FILESYSTEM2_NARROW_ONLY
 
       BOOST_FILESYSTEM_DECL fs::file_status
       status_api( const std::wstring & ph, error_code & ec )
@@ -806,7 +806,7 @@
         return ok;
       }
 
-#     endif // ifndef BOOST_FILESYSTEM_NARROW_ONLY
+#     endif // ifndef BOOST_FILESYSTEM2_NARROW_ONLY
 
       // suggested by Walter Landry
       BOOST_FILESYSTEM_DECL bool symbolic_link_exists_api( const std::string & )
Index: libs/filesystem/v2/example/mbcopy.cpp
===================================================================
--- libs/filesystem/v2/example/mbcopy.cpp	(revision 64557)
+++ libs/filesystem/v2/example/mbcopy.cpp	(working copy)
@@ -13,7 +13,7 @@
 #define BOOST_FILESYSTEM_NO_DEPRECATED
 
 #include <boost/filesystem/config.hpp>
-# ifdef BOOST_FILESYSTEM_NARROW_ONLY
+# ifdef BOOST_FILESYSTEM2_NARROW_ONLY
 #   error This compiler or standard library does not support wide-character strings or paths
 # endif
 
Index: libs/filesystem/v2/example/mbpath.cpp
===================================================================
--- libs/filesystem/v2/example/mbpath.cpp	(revision 64557)
+++ libs/filesystem/v2/example/mbpath.cpp	(working copy)
@@ -9,7 +9,7 @@
 //  See Boost.Filesystem home page at http://www.boost.org/libs/filesystem
 
 #include <boost/filesystem/config.hpp>
-# ifdef BOOST_FILESYSTEM_NARROW_ONLY
+# ifdef BOOST_FILESYSTEM2_NARROW_ONLY
 #   error This compiler or standard library does not support wide-character strings or paths
 # endif
 