Index: libs/wave/doc/class_ref_ctxpolicy_depr.html
===================================================================
--- libs/wave/doc/class_ref_ctxpolicy_depr.html	(revision 49184)
+++ libs/wave/doc/class_ref_ctxpolicy_depr.html	(working copy)
@@ -46,7 +46,7 @@
 </ul>
 <p>This policy type is used as a template parameter to the <a href="class_reference_context.html"><tt>boost::wave::context&lt;&gt;</tt></a> 
   object, where the default policy provides empty hook functions only.</p>
-<h2><a name="header_synopsis"></a>Header <a href="http://cvs.sourceforge.net/viewcvs.py/boost/boost/boost/wave/preprocessing_hooks.hpp?view=markup">wave/preprocessing_hooks.hpp</a> 
+<h2><a name="header_synopsis"></a>Header <a href="http://svn.boost.org/trac/boost/browser/trunk/boost/wave/preprocessing_hooks.hpp">wave/preprocessing_hooks.hpp</a> 
   synopsis</h2>
 <pre>
 <span class="keyword">namespace</span> boost {
Index: libs/wave/doc/class_reference_context.html
===================================================================
--- libs/wave/doc/class_reference_context.html	(revision 49184)
+++ libs/wave/doc/class_reference_context.html	(working copy)
@@ -45,7 +45,7 @@
     other options as for instance to control, whether to enable several extensions 
     to the C++ Standard (as for instance variadics and placemarkers) or not.</p>
 </blockquote>
-<h2><b><a name="header_synopsis"></a>Header <a href="http://cvs.sourceforge.net/viewcvs.py/boost/boost/boost/wave/cpp_context.hpp?view=markup">wave/cpp_context.hpp</a> 
+<h2><b><a name="header_synopsis"></a>Header <a href="http://svn.boost.org/trac/boost/browser/trunk/boost/wave/cpp_context.hpp">wave/cpp_context.hpp</a> 
   synopsis</b></h2>
 <pre><span class="keyword">namespace</span> <span class="identifier">boost</span> {
 <span class="keyword">namespace</span> <span class="identifier">wave</span> { 
Index: libs/wave/doc/class_reference_ctxpolicy.html
===================================================================
--- libs/wave/doc/class_reference_ctxpolicy.html	(revision 49184)
+++ libs/wave/doc/class_reference_ctxpolicy.html	(working copy)
@@ -45,7 +45,7 @@
 </ul>
 <p>This policy type is used as a template parameter to the <a href="class_reference_context.html"><tt>boost::wave::context&lt;&gt;</tt></a> 
   object, where the default policy provides empty hook functions only.</p>
-<h2><a name="header_synopsis"></a>Header <a href="http://cvs.sourceforge.net/viewcvs.py/boost/boost/boost/wave/preprocessing_hooks.hpp?view=markup">wave/preprocessing_hooks.hpp</a> 
+<h2><a name="header_synopsis"></a>Header <a href="http://svn.boost.org/trac/boost/browser/trunk/boost/wave/preprocessing_hooks.hpp">wave/preprocessing_hooks.hpp</a> 
   synopsis</h2>
 <pre>
 <span class="keyword">namespace</span> boost {
Index: libs/wave/doc/class_reference_filepos.html
===================================================================
--- libs/wave/doc/class_reference_filepos.html	(revision 49184)
+++ libs/wave/doc/class_reference_filepos.html	(working copy)
@@ -35,7 +35,7 @@
 <p>The file position template is used to represent a concrete token position inside 
   the underlying input stream. This token position contains the corresponding 
   filename, the line number and the column number, where the token was recognized.</p>
-<h2><b><a name="header_synopsis"></a>Header <a href="http://cvs.sourceforge.net/viewcvs.py/boost/boost/boost/wave/util/file_position.hpp?view=markup">wave/util/file_position.hpp</a> 
+<h2><b><a name="header_synopsis"></a>Header <a href="http://svn.boost.org/trac/boost/browser/trunk/boost/wave/util/file_position.hpp">wave/util/file_position.hpp</a> 
   synopsis</b></h2>
 <pre><span class="keyword">namespace</span> <span class="identifier">boost</span> {
 <span class="keyword">namespace</span> <span class="identifier">wave</span> {
Index: libs/wave/doc/class_reference_inptpolcy.html
===================================================================
--- libs/wave/doc/class_reference_inptpolcy.html	(revision 49184)
+++ libs/wave/doc/class_reference_inptpolcy.html	(working copy)
@@ -39,7 +39,7 @@
   input sequence. If this template parameter is not given while instantiating 
   the context object, it defaults to the <tt>iteration_context_policies::load_file_to_string</tt> 
   type. </p>
-<h2><b><a name="header_synopsis"></a>Header <a href="http://cvs.sourceforge.net/viewcvs.py/boost/boost/boost/wave/util/iteration_context.hpp?view=markup">wave/iteration_context.hpp</a> 
+<h2><b><a name="header_synopsis"></a>Header <a href="http://svn.boost.org/trac/boost/browser/trunk/boost/wave/util/iteration_context.hpp">wave/iteration_context.hpp</a> 
   synopsis</b></h2>
 <p>The following code listing does not show the required interface only, but for 
   brevity reasons the whole implementation of an input policy, which loads the 
Index: libs/wave/doc/class_reference_lexer.html
===================================================================
--- libs/wave/doc/class_reference_lexer.html	(revision 49184)
+++ libs/wave/doc/class_reference_lexer.html	(working copy)
@@ -34,7 +34,7 @@
 <h2><b><a name="introduction"></a>Introduction</b></h2>
 <p>Every lexer, which should be used in conjunction with the <tt>Wave</tt> library, has to return tokens formed from the input stream. These tokens should conform to the synopsis described in the topic <a href="class_reference_tokentype.html">The Token Type</a>. The lexer type should expose an interface which conforms at least to a <tt>forward_iterator</tt> (in the sense defined by the the C++ Standard) returning the token type. The code sample below does not show the definition of this forward iterator interface because this is highly implementation defined.</p>
 <h2><a name="header_synopsis"></a>Wave lexer  
-  synopsis (header: <a href="http://cvs.sourceforge.net/viewcvs.py/boost/boost/boost/wave/cpplexer/cpp_lex_interface.hpp?view=markup">wave/cpplexer/cpp_lexer_interface.hpp</a>)</h2>
+  synopsis (header: <a href="http://svn.boost.org/trac/boost/browser/trunk/boost/wave/cpplexer/cpp_lex_interface.hpp">wave/cpplexer/cpp_lexer_interface.hpp</a>)</h2>
 <pre>    <span class="keyword">struct</span> lex_iterator
     {
         <span class="keyword">typedef</span> boost::wave::lex_token&lt;&gt; <a href="class_reference_lexer.html#public_typedefs">token_type</a>;
@@ -53,7 +53,7 @@
     };
 
 </pre>
-<p>Please note, that the <tt>lex_iterator</tt> defined in the library header <a href="http://cvs.sourceforge.net/viewcvs.py/boost/boost/boost/wave/cpplexer/cpp_lex_interface.hpp?view=markup">wave/cpplexer/cpp_lexer_interface.hpp</a> actually is a template class taking the token type to use as its template parameter. This is omitted in the synopsis above because it is an implementation detail of the  Re2C lexer provided as part of the Wave library.</p>
+<p>Please note, that the <tt>lex_iterator</tt> defined in the library header <a href="http://svn.boost.org/trac/boost/browser/trunk/boost/wave/cpplexer/cpp_lex_interface.hpp">wave/cpplexer/cpp_lexer_interface.hpp</a> actually is a template class taking the token type to use as its template parameter. This is omitted in the synopsis above because it is an implementation detail of the  Re2C lexer provided as part of the Wave library.</p>
 <p>If you want to use Wave in conjunction with your own lexing component this will have to conform to the interface described above only. </p>
 <h2><a name="public_typedefs" id="public_typedefs"></a>Public Typedefs</h2>
 <p>Besides the typedefs mandated for a <tt>forward_iterator</tt> by the C++ standard every lexer to be used with the <tt>Wave</tt> library should define the following typedefs: </p>
Index: libs/wave/doc/class_reference_tokentype.html
===================================================================
--- libs/wave/doc/class_reference_tokentype.html	(revision 49184)
+++ libs/wave/doc/class_reference_tokentype.html	(working copy)
@@ -50,7 +50,7 @@
   library, which is used in conjunction with the two predefined C++ lexers contained 
   in the <tt>Wave</tt> library too. If you need to use your own token type, it 
   is required to implement the interafce described below.</p>
-<h2><b><a name="header_synopsis"></a>Header <a href="http://cvs.sourceforge.net/viewcvs.py/boost/boost/boost/wave/cpplexer/cpp_lex_token.hpp?view=markup">wave/cpplexer/cpp_lex_token.hpp</a> 
+<h2><b><a name="header_synopsis"></a>Header <a href="http://svn.boost.org/trac/boost/browser/trunk/boost/wave/cpplexer/cpp_lex_token.hpp">wave/cpplexer/cpp_lex_token.hpp</a> 
   synopsis</b></h2>
 <pre><span class="keyword">namespace</span> boost {
 <span class="keyword">namespace</span> wave {